=begin
#ChannelShipper & Royal Mail Public API

#Import your orders, retrieve your orders and generate labels.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

module RoyalMail
  class OrdersApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create orders
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [CreateOrdersResponse]
    def create_orders_async(body, opts = {})
      data, _status_code, _headers = create_orders_async_with_http_info(body, opts)
      data
    end

    # Create orders
    # @param body 
    # @param [Hash] opts the optional parameters
    # @return [Array<(CreateOrdersResponse, Integer, Hash)>] CreateOrdersResponse data, response status code and response headers
    def create_orders_async_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OrdersApi.create_orders_async ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling OrdersApi.create_orders_async"
      end
      # resource path
      local_var_path = '/orders'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] || 'CreateOrdersResponse' 

      auth_names = opts[:auth_names] || ['Bearer']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OrdersApi#create_orders_async\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete orders
    # <b>Reserved for ChannelShipper customers only - please visit <a href=\"https://channelshipper.com/\" target=\"_self\">ChannelShipper.com</a> for more information</b>  Please be aware labels generated on orders which are deleted are no longer valid and must be destroyed.  Cancelled label information is automatically shared with Royal Mail Revenue Protection, and should a cancelled label be identified on an item in the Royal Mail Network, you will be charged on your account and an additional handling fee applied. 
    # @param order_identifiers One or several Order Identifiers or Order References separated by semicolon. Order Identifiers are integer numbers. Order References are strings - each must be percent-encoded and surrounded by double quotation marks. The maximum number of identifiers is 100.
    # @param [Hash] opts the optional parameters
    # @return [DeleteOrdersResource]
    def delete_orders_async(order_identifiers, opts = {})
      data, _status_code, _headers = delete_orders_async_with_http_info(order_identifiers, opts)
      data
    end

    # Delete orders
    # &lt;b&gt;Reserved for ChannelShipper customers only - please visit &lt;a href&#x3D;\&quot;https://channelshipper.com/\&quot; target&#x3D;\&quot;_self\&quot;&gt;ChannelShipper.com&lt;/a&gt; for more information&lt;/b&gt;  Please be aware labels generated on orders which are deleted are no longer valid and must be destroyed.  Cancelled label information is automatically shared with Royal Mail Revenue Protection, and should a cancelled label be identified on an item in the Royal Mail Network, you will be charged on your account and an additional handling fee applied. 
    # @param order_identifiers One or several Order Identifiers or Order References separated by semicolon. Order Identifiers are integer numbers. Order References are strings - each must be percent-encoded and surrounded by double quotation marks. The maximum number of identifiers is 100.
    # @param [Hash] opts the optional parameters
    # @return [Array<(DeleteOrdersResource, Integer, Hash)>] DeleteOrdersResource data, response status code and response headers
    def delete_orders_async_with_http_info(order_identifiers, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OrdersApi.delete_orders_async ...'
      end
      # verify the required parameter 'order_identifiers' is set
      if @api_client.config.client_side_validation && order_identifiers.nil?
        fail ArgumentError, "Missing the required parameter 'order_identifiers' when calling OrdersApi.delete_orders_async"
      end
      # resource path
      local_var_path = '/orders/{orderIdentifiers}'.sub('{' + 'orderIdentifiers' + '}', order_identifiers.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'DeleteOrdersResource' 

      auth_names = opts[:auth_names] || ['Bearer']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OrdersApi#delete_orders_async\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve pageable list of orders
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size The number of items to return (default to 25)
    # @option opts [DateTime] :start_date_time Date and time lower bound for items filtering
    # @option opts [DateTime] :end_date_time Date and time upper bound for items filtering
    # @option opts [String] :continuation_token The token for retrieving the next page of items
    # @return [GetOrdersResponse]
    def get_orders_async(opts = {})
      data, _status_code, _headers = get_orders_async_with_http_info(opts)
      data
    end

    # Retrieve pageable list of orders
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size The number of items to return
    # @option opts [DateTime] :start_date_time Date and time lower bound for items filtering
    # @option opts [DateTime] :end_date_time Date and time upper bound for items filtering
    # @option opts [String] :continuation_token The token for retrieving the next page of items
    # @return [Array<(GetOrdersResponse, Integer, Hash)>] GetOrdersResponse data, response status code and response headers
    def get_orders_async_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OrdersApi.get_orders_async ...'
      end
      # resource path
      local_var_path = '/orders'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'startDateTime'] = opts[:'start_date_time'] if !opts[:'start_date_time'].nil?
      query_params[:'endDateTime'] = opts[:'end_date_time'] if !opts[:'end_date_time'].nil?
      query_params[:'continuationToken'] = opts[:'continuation_token'] if !opts[:'continuation_token'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'GetOrdersResponse' 

      auth_names = opts[:auth_names] || ['Bearer']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OrdersApi#get_orders_async\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve pageable list of orders with details
    # <b>Reserved for ChannelShipper customers only - please visit <a href=\"https://channelshipper.com/\" target=\"_self\">ChannelShipper.com</a> for more information</b>
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size The number of items to return (default to 25)
    # @option opts [DateTime] :start_date_time Date and time lower bound for items filtering
    # @option opts [DateTime] :end_date_time Date and time upper bound for items filtering
    # @option opts [String] :continuation_token The token for retrieving the next page of items
    # @return [GetOrdersDetailsResponse]
    def get_orders_with_details_async(opts = {})
      data, _status_code, _headers = get_orders_with_details_async_with_http_info(opts)
      data
    end

    # Retrieve pageable list of orders with details
    # &lt;b&gt;Reserved for ChannelShipper customers only - please visit &lt;a href&#x3D;\&quot;https://channelshipper.com/\&quot; target&#x3D;\&quot;_self\&quot;&gt;ChannelShipper.com&lt;/a&gt; for more information&lt;/b&gt;
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page_size The number of items to return
    # @option opts [DateTime] :start_date_time Date and time lower bound for items filtering
    # @option opts [DateTime] :end_date_time Date and time upper bound for items filtering
    # @option opts [String] :continuation_token The token for retrieving the next page of items
    # @return [Array<(GetOrdersDetailsResponse, Integer, Hash)>] GetOrdersDetailsResponse data, response status code and response headers
    def get_orders_with_details_async_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OrdersApi.get_orders_with_details_async ...'
      end
      # resource path
      local_var_path = '/orders/full'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'pageSize'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'startDateTime'] = opts[:'start_date_time'] if !opts[:'start_date_time'].nil?
      query_params[:'endDateTime'] = opts[:'end_date_time'] if !opts[:'end_date_time'].nil?
      query_params[:'continuationToken'] = opts[:'continuation_token'] if !opts[:'continuation_token'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'GetOrdersDetailsResponse' 

      auth_names = opts[:auth_names] || ['Bearer']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OrdersApi#get_orders_with_details_async\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve specific orders
    # @param order_identifiers One or several Order Identifiers or Order References separated by semicolon. Order Identifiers are integer numbers. Order References are strings - each must be percent-encoded and surrounded by double quotation marks. The maximum number of identifiers is 100.
    # @param [Hash] opts the optional parameters
    # @return [Array<GetOrderInfoResource>]
    def get_specific_orders_async(order_identifiers, opts = {})
      data, _status_code, _headers = get_specific_orders_async_with_http_info(order_identifiers, opts)
      data
    end

    # Retrieve specific orders
    # @param order_identifiers One or several Order Identifiers or Order References separated by semicolon. Order Identifiers are integer numbers. Order References are strings - each must be percent-encoded and surrounded by double quotation marks. The maximum number of identifiers is 100.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<GetOrderInfoResource>, Integer, Hash)>] Array<GetOrderInfoResource> data, response status code and response headers
    def get_specific_orders_async_with_http_info(order_identifiers, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OrdersApi.get_specific_orders_async ...'
      end
      # verify the required parameter 'order_identifiers' is set
      if @api_client.config.client_side_validation && order_identifiers.nil?
        fail ArgumentError, "Missing the required parameter 'order_identifiers' when calling OrdersApi.get_specific_orders_async"
      end
      # resource path
      local_var_path = '/orders/{orderIdentifiers}'.sub('{' + 'orderIdentifiers' + '}', order_identifiers.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<GetOrderInfoResource>' 

      auth_names = opts[:auth_names] || ['Bearer']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OrdersApi#get_specific_orders_async\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Retrieve details of the specific orders
    # <b>Reserved for ChannelShipper customers only - please visit <a href=\"https://channelshipper.com/\" target=\"_self\">ChannelShipper.com</a> for more information</b>
    # @param order_identifiers One or several Order Identifiers or Order References separated by semicolon. Order Identifiers are integer numbers. Order References are strings - each must be percent-encoded and surrounded by double quotation marks. The maximum number of identifiers is 100.
    # @param [Hash] opts the optional parameters
    # @return [Array<GetOrderDetailsResource>]
    def get_specific_orders_with_details_async(order_identifiers, opts = {})
      data, _status_code, _headers = get_specific_orders_with_details_async_with_http_info(order_identifiers, opts)
      data
    end

    # Retrieve details of the specific orders
    # &lt;b&gt;Reserved for ChannelShipper customers only - please visit &lt;a href&#x3D;\&quot;https://channelshipper.com/\&quot; target&#x3D;\&quot;_self\&quot;&gt;ChannelShipper.com&lt;/a&gt; for more information&lt;/b&gt;
    # @param order_identifiers One or several Order Identifiers or Order References separated by semicolon. Order Identifiers are integer numbers. Order References are strings - each must be percent-encoded and surrounded by double quotation marks. The maximum number of identifiers is 100.
    # @param [Hash] opts the optional parameters
    # @return [Array<(Array<GetOrderDetailsResource>, Integer, Hash)>] Array<GetOrderDetailsResource> data, response status code and response headers
    def get_specific_orders_with_details_async_with_http_info(order_identifiers, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OrdersApi.get_specific_orders_with_details_async ...'
      end
      # verify the required parameter 'order_identifiers' is set
      if @api_client.config.client_side_validation && order_identifiers.nil?
        fail ArgumentError, "Missing the required parameter 'order_identifiers' when calling OrdersApi.get_specific_orders_with_details_async"
      end
      # resource path
      local_var_path = '/orders/{orderIdentifiers}/full'.sub('{' + 'orderIdentifiers' + '}', order_identifiers.to_s)

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      return_type = opts[:return_type] || 'Array<GetOrderDetailsResource>' 

      auth_names = opts[:auth_names] || ['Bearer']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OrdersApi#get_specific_orders_with_details_async\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Set order status
    # @param body At least one of &#x27;orderIdentifier&#x27; and &#x27;orderReference&#x27; is required. Providing both is disallowed to avoid ambiguity.

    # When the status is set to &#x27;despatchedByOtherCourier&#x27;, if the optional parameter &#x27;trackingNumber&#x27; is provided
    # then the parameters &#x27;despatchDate&#x27;, &#x27;shippingCarrier&#x27; and &#x27;shippingService&#x27; are also required.
    # The maximum collection lenght is 100.

    # @param [Hash] opts the optional parameters
    # @return [UpdateOrderStatusResponse]
    def update_orders_status_async(body, opts = {})
      data, _status_code, _headers = update_orders_status_async_with_http_info(body, opts)
      data
    end

    # Set order status
    # @param body At least one of &#x27;orderIdentifier&#x27; and &#x27;orderReference&#x27; is required. Providing both is disallowed to avoid ambiguity.

    # When the status is set to &#x27;despatchedByOtherCourier&#x27;, if the optional parameter &#x27;trackingNumber&#x27; is provided
    # then the parameters &#x27;despatchDate&#x27;, &#x27;shippingCarrier&#x27; and &#x27;shippingService&#x27; are also required.
    # The maximum collection lenght is 100.

    # @param [Hash] opts the optional parameters
    # @return [Array<(UpdateOrderStatusResponse, Integer, Hash)>] UpdateOrderStatusResponse data, response status code and response headers
    def update_orders_status_async_with_http_info(body, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: OrdersApi.update_orders_status_async ...'
      end
      # verify the required parameter 'body' is set
      if @api_client.config.client_side_validation && body.nil?
        fail ArgumentError, "Missing the required parameter 'body' when calling OrdersApi.update_orders_status_async"
      end
      # resource path
      local_var_path = '/orders/status'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(body) 

      return_type = opts[:return_type] || 'UpdateOrderStatusResponse' 

      auth_names = opts[:auth_names] || ['Bearer']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type)

      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: OrdersApi#update_orders_status_async\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
